VelocimacroManager (Velocity 1.7 API)
Keywords: org.apache.velocity.runtime.VelocimacroManager class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.velocity.runtime
Class VelocimacroManager

    java.lang.Object
      org.apache.velocity.runtime.VelocimacroManager

public class VelocimacroManager
extends Object

Manages VMs in namespaces. Currently, two namespace modes are supported:

- flat - all allowable VMs are in the global namespace
- local - inline VMs are added to it's own template namespace

Thanks to Jose Alberto Fernandez for some ideas incorporated here.

Version:
  $Id: VelocimacroManager.java 992115 2010-09-02 21:00:10Z nbubna $
Author:
  Geir Magnusson Jr., Jose Alberto Fernandez

Method Summary
`boolean` | `addVM(String vmName, Node macroBody, String[] argArray, String namespace, boolean canReplaceGlobalMacro)` Adds a VM definition to the cache.
`boolean` | `dumpNamespace(String namespace)` Removes the VMs and the namespace from the manager.
`VelocimacroProxy` | `get(String vmName, String namespace)` Gets a VelocimacroProxy object by the name / source template duple.
`VelocimacroProxy` | `get(String vmName, String namespace, String renderingTemplate)` Gets a VelocimacroProxy object by the name / source template duple.
`String` | `getLibraryName(String vmName, String namespace)` Return the library name for a given macro.
`void` | `setInlineReplacesGlobal(boolean is)`
`void` | `setNamespaceUsage(boolean namespaceOn)` public switch to let external user of manager to control namespace usage indep of properties.
`void` | `setRegisterFromLib(boolean registerFromLib)` Should macros registered from Libraries be marked special?
`void` | `setTemplateLocalInlineVM(boolean inlineLocalMode)` Should macros from the same template be inlined?

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### addVM

    public boolean addVM(String vmName,
                         Node macroBody,
                         String[] argArray,
                         String namespace,
                         boolean canReplaceGlobalMacro)

  Adds a VM definition to the cache. Called by VelocimacroFactory.addVelociMacro (after parsing and discovery in Macro directive)

  Parameters:
    `vmName` - Name of the new VelociMacro.
    `macroBody` - String representation of the macro body.
    `argArray` - Array of macro parameters, first parameter is the macro name.
    `namespace` - The namespace/template from which this macro has been loaded.
  Returns:
    Whether everything went okay.

### get

    public VelocimacroProxy get(String vmName,
                                String namespace)

  Gets a VelocimacroProxy object by the name / source template duple.

  Parameters:
    `vmName` - Name of the VelocityMacro to look up.
    `namespace` - Namespace in which to look up the macro.
  Returns:
    A proxy representing the Macro.

### get

    public VelocimacroProxy get(String vmName,
                                String namespace,
                                String renderingTemplate)

  Gets a VelocimacroProxy object by the name / source template duple.

  Parameters:
    `vmName` - Name of the VelocityMacro to look up.
    `namespace` - Namespace in which to look up the macro.
    `renderingTemplate` - Name of the template we are currently rendering.
  Returns:
    A proxy representing the Macro.
  Since:
    1.6

### dumpNamespace

    public boolean dumpNamespace(String namespace)

  Removes the VMs and the namespace from the manager. Used when a template is reloaded to avoid losing memory.

  Parameters:
    `namespace` - namespace to dump
  Returns:
    boolean representing success

### setNamespaceUsage

    public void setNamespaceUsage(boolean namespaceOn)

  public switch to let external user of manager to control namespace usage indep of properties. That way, for example, at startup the library files are loaded into global namespace

  Parameters:
    `namespaceOn` - True if namespaces should be used.

### setRegisterFromLib

    public void setRegisterFromLib(boolean registerFromLib)

  Should macros registered from Libraries be marked special?

  Parameters:
    `registerFromLib` - True if macros from Libs should be marked.

### setTemplateLocalInlineVM

    public void setTemplateLocalInlineVM(boolean inlineLocalMode)

  Should macros from the same template be inlined?

  Parameters:
    `inlineLocalMode` - True if macros should be inlined on the same template.

### getLibraryName

    public String getLibraryName(String vmName,
                                 String namespace)

  Return the library name for a given macro.

  Parameters:
    `vmName` - Name of the Macro to look up.
    `namespace` - Namespace to look the macro up.
  Returns:
    The name of the library which registered this macro in a namespace.

### setInlineReplacesGlobal

    public void setInlineReplacesGlobal(boolean is)

  Since:
    1.6

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2010 Apache Software Foundation. All Rights Reserved.